Subject: [bitcoindev] Re: Mandatory Inclusion of Old Transactions in Blocks

From: Owen Kemeys <[email-masked]>
Date: Sat, 28 Dec 2024 08:23:03 -0800 (PST)

Hi,
Mempools are local to each node and there can never be any guarantee any 
given node has seen any given transaction. This proposal would result in 
regular chainsplits as some nodes reject blocks for failing to include 
ancient transactions that the miner simply did not know about.
If we could be sure that all nodes had seen all transactions and agreed on 
their age and ordering, we would not need to bother with mining.

On Saturday, 28 December 2024 at 09:58:16 UTC-6 developer wrote:

> Status: Draft
> Type: Standards Track
> Created: December 27, 2024
> Abstract
>
> This proposal mandates miners to include at least 0.1% of transactions in 
> their blocks from the oldest transactions by date, even if they have low 
> fees. This mechanism helps prevent mining centralization and censorship, 
> encouraging miners not to exclude certain transactions.
> Motivation
>
> The increasing centralization of Bitcoin mining and potential regulations 
> that may require miners to censor or exclude certain transactions pose a 
> threat to the Bitcoin network. Mandating the inclusion of a small 
> percentage of old transactions, even with low fees, ensures that no single 
> miner can censor block contents without sacrificing their own rewards.
> Specification
>
>     Mandatory Inclusion of Old even if with Low-Fee Transactions
>         Each miner is required to include at least 0.1% of the total 
> transactions in a block from the oldest transactions in the mempool, even 
> if their fees are below the current market average.
>         These transactions must be added to blocks regardless of their 
> fees, prioritizing their age.
>
>     Block Validation
>         Bitcoin network nodes will validate blocks only if they contain 
> the required percentage of old transactions.
>         If a block fails to meet this criterion, it will be deemed invalid 
> and rejected by the network.
>
>     Incentives
>         Miners are incentivized to include these transactions to ensure 
> their blocks are valid and to avoid losing block rewards.
>
> Advantages
>
>     Censorship Resistance: Miners cannot censor transactions without 
> forfeiting their rewards.
>     Greater Inclusivity: Old and low-fee transactions are assured of being 
> confirmed.
>     Decentralization Prevention: Reducing the potential for centralized 
> censorship keeps the Bitcoin network decentralized.
>
> Considerations
>
>     Impact on the Mempool: The mempool may become more dynamic and 
> up-to-date with fewer old, stagnant transactions.
>     Resource Management: Miners will need to adjust their systems to 
> automatically identify and include relevant transactions.
>
> Conclusion
>
> Implementing this BIP will help maintain the integrity and 
> decentralization of the Bitcoin network, preventing censorship and ensuring 
> all transactions have a fair chance of confirmation.

-- 
You received this message because you are subscribed to the Google Groups "Bitcoin Development Mailing List" group.
To unsubscribe from this group and stop receiving emails from it, send an email to [email-masked].
To view this discussion visit https://groups.google.com/d/msgid/bitcoindev/1b011053-d041-4a42-b56b-a4edd269391bn%40googlegroups.com.